<?php
$berogui_path = '/usr/local/www/berogui';
require("$berogui_path/includes/Helper/Helper.php");

##### INTERN FUNCTIONS #####
function cleanberoConf($bc = null) {
	if (is_null($bc)) {
		require_once('/usr/fallback/beroConf.php');
		$bc = new beroConf('root');
	}

	foreach (['sbcvmupdate-notif', 'has-major-issue', 'sbcvm-has-update', 'sbcvm-rebooting', 'sbcvmupdate-completed', 'sbcvmupdate-nb-request'] as $key) {
		$bc->delete('root', $key);
	}
}
function doUpdate($reboot_required) {
	$output = null;	
	$cmd =	'export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/snap/bin:$PATH;'
				. "/bin/bash /usr/local/beroNet/bin/sbcvm-update $reboot_required >/dev/null";
	$retval = Helper::system(1, $cmd, $output, ['timeout' => 300]);
	return $retval != false;
}

##### FORCE UPDATE AFTER AUTO FAILED OR TO FIX A MAJOR ISSUE ######
if (isset($_POST['force-update']) && $_POST['force-update']) {
	require("$berogui_path/misc/database.php");
	$ba = new beroAri();

	require_once("$berogui_path/includes/lang.php");
	if (Helper::getActivateOption() != '0') {
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED_ACTIVATE_NOTIF]));
	}
	else if (Helper::getTotalCalls() != '0') {
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED_ACTCALLS_NOTIF]));
	}

	### file overwritten during update. should lead to a fail
	doUpdate(0);
}
else if (isset($_POST['check_update']) && $_POST['check_update']) {
	require_once('/usr/fallback/beroConf.php');
	$bc = new beroConf('root');

	require("$berogui_path/misc/database.php");
	$ba = new beroAri();

	require_once("$berogui_path/includes/lang.php");
	// update successful and completed
	if ($bc->get('root', 'sbcvmupdate-completed') == 1) {
		cleanberoConf($bc);
		header('Content-type: application/json');
		die(Helper::jsonEncode(['current_package' => $bc->get('root', 'sbcvm-current-package'), 'success' => UPDATE_TOOL_SBCVM_SUCCESSFUL]));
	}
	// a reboot is required. we answer to update GUI
	else if ($bc->get('root', 'sbcvm-rebooting') == 1) {
		cleanberoConf($bc);
		header('Content-type: application/json');
		die(Helper::jsonEncode(['rebooting' => UPDATE_TOOL_SBCVM_REBOOTING]));
	}
	// more than 600 request == 600 seconds == 10min: an issue occurs
	else if ($bc->get('root', 'sbcvm-nb-request') > 600) {
		$bc->delete('root', 'sbcvmupdate-nb-request');
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED]));
	}
	sleep(1);
	$bc->set('root', 'sbcvmupdate-nb-request', (int) $bc->get('root', 'sbcvmupdate-nb-request') + 1);
	die();
}

##### MANUAL UPDATE #####
/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST);

/* [EXEC AJAX] */
require_once('/usr/fallback/beroConf.php');
$bc = new beroConf('root');

### file overwritte during update. should lead to a fail
$reboot_required = $bc->get('root', 'sbcvmupdate-reboot') == 1 ? 1 : 0;
doUpdate($reboot_required);
exit(1);
?>
